#############################################################################################
# TclMiniSplash
# Except where otherwise noted, TclMiniSplash is (C) Peter Caffin, 2009-.
# For more info: http://tclminisplash.autons.net/
#############################################################################################

package provide tclminisplash 0.01

namespace eval tclminisplash {
#############################################################################################

proc Start {msg} {
 toplevel .pleasewait
 wm overrideredirect .pleasewait 1
 set ::tclminisplash::value .
 grid [label .pleasewait.message -text $msg] -row 0 -column 0 -padx "40 0" -pady 10 
 grid [label .pleasewait.spinner -text $::tclminisplash::value -width 2 -justify left] -row 0 -column 1 -padx "0 40" -pady 10 -sticky w
 focus .pleasewait ; grab .pleasewait
 ::tk::PlaceWindow .pleasewait widget {}
 if {[tk windowingsystem]=="aqua"} { foreach w {.pleasewait .pleasewait.message .pleasewait.spinner} { $w configure -background systemModelessDialogBackgroundActive } }
 update
 ::tclminisplash::UpdateSpinner
 }

proc UpdateSpinner {} {
 if {![winfo exists .pleasewait.spinner]} { return } else { after 100 { ::tclminisplash::UpdateSpinner } }

 switch -- $::tclminisplash::value { 
  "." { set ::tclminisplash::value .. }
  ".." { set ::tclminisplash::value ... }
  "..." { set ::tclminisplash::value "...." }
  "...." { set ::tclminisplash::value "." }
  default { set ::tclminisplash::value "." }
  }
 .pleasewait.spinner configure -text $::tclminisplash::value -width 2 -justify left
 update
 }
 
proc End {} {
 grab release .pleasewait
 destroy .pleasewait
 update
 }

#############################################################################################
}
